//******************************************************************************
//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// This code numerically computes the Cramer-Rao bound for the variance of
// the frequency offset estimate.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
clear;
clf;
timer();
//******************************************************************************
PRE_AMB_SIZE=512;                                     // Length of the preamble.
CHAN_MEM=9;                                         // Length of channel memory.
CHAN_LEN=CHAN_MEM+1;                                       // Length of channel.
FOFF_EST_RX_SIZE=PRE_AMB_SIZE+CHAN_LEN-1;     // Size of rx. vec. for freq. est.
Rx_Sig_Var=1.0;                                  // Variance of received signal.
Char_Func_Step=0.00000001;
Z_Step=10000.0;
Z_Max=10000000.0;
Z_Inx=1;
L_LIM=150;
k=[1:FOFF_EST_RX_SIZE];
k=k.^2;
//******************************************************************************
for z=0:Z_Step:Z_Max
 PDF_Z(Z_Inx)=0.0;
 for l=-L_LIM:L_LIM
  Prod_Vec=1.0-%i*2.0*l*Char_Func_Step*k*Rx_Sig_Var;
  Prod_l=prod(Prod_Vec);
  Prod_l=exp(-%i*l*Char_Func_Step*z)/Prod_l;
  PDF_Z(Z_Inx)=PDF_Z(Z_Inx)+Prod_l;
 end;
 PDF_Z(Z_Inx)=PDF_Z(Z_Inx)*Char_Func_Step/(2*%pi);
 Z_Inx=Z_Inx+1;
end;
//******************************************************************************
