//******************************************************************************
//******************************************************************************
//*   Copyright (C) 2010 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Basic DMT code. Channel is known, synchronization is assumed, noise is
// absent.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
clear;
FRAME_SIZE=4;
CHAN_MEM=3;
CHAN_LEN=CHAN_MEM+1;
Chan=[1 2 3 4];
Chan_Energy=abs(Chan)*abs(Chan)';
Chan=Chan/sqrt(Chan_Energy);
Chan_FFT=fft(Chan);
Tx_Bits=grand(1,FRAME_SIZE,'def');
Tx_Bits=int(2*Tx_Bits);
Tx_Sym=2*Tx_Bits-1;
Sym_IFFT=ifft(Tx_Sym);
Chan_Ip=[Sym_IFFT(FRAME_SIZE-CHAN_MEM+1:FRAME_SIZE) Sym_IFFT];
Chan_Op=convol(Chan_Ip,Chan);
Rx_Sig=Chan_Op(CHAN_LEN:FRAME_SIZE+CHAN_MEM);
Rx_FFT_Op=fft(Rx_Sig);
Rx_Sym=Rx_FFT_Op./Chan_FFT;
Rx_Sym=round(Rx_Sym);
Rx_Bits=(Rx_Sym+1)/2;
Error_Vec=setdiff(Tx_Bits,Rx_Bits);
Ber=size(Error_Vec,'c');
