//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get channel output.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
function[Chan_Op,Outage]=Get_Channel_Op(Chan,Chan_Ip,FOFF_Vec,Outage)
 Chan_Op=convol(Chan,Chan_Ip);
 Chan_Op=Chan_Op.*FOFF_Vec;                       // Introduce frequency offset.
 Chan_Op_Data=Chan_Op(PRE_AMB_SIZE+1:$);                    // Exclude preamble.
 Sig_Pow=Chan_Op_Data*Chan_Op_Data';
 Re_Noise=grand(Chan_Op,'nor',NOISE_MEAN,NOISE_STD);
 Im_Noise=grand(Chan_Op,'nor',NOISE_MEAN,NOISE_STD);
 Noise=Re_Noise+%i*Im_Noise;
 Noise_Data=Noise(PRE_AMB_SIZE+1:$);                        // Exclude preamble.
 Noise_Pow=Noise_Data*Noise_Data';
 Chan_Op=Chan_Op+Noise;
 Frame_SNR=abs(Sig_Pow/Noise_Pow);
 Outage(find(Frame_SNR<SNR_THRESH))=Outage(find(Frame_SNR<SNR_THRESH))+1;
endfunction
