//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// MAP (BCJR) algorithm for decoder 2.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
function[Prob]= Dec2_Process_End(Prob,my_size)
//******************************************************************************
// Initialize alpha and beta.
//******************************************************************************
 my_alpha=zeros(NUM_STATES,my_size);
 my_beta=zeros(NUM_STATES,my_size+1);
 my_alpha(:,1)=1.0;
 my_beta(:,my_size+1)=1.0;
//******************************************************************************
// Initialize probabilities.
//******************************************************************************
 p10=Prob(1,:)+Prob(2,:);
 p20=Prob(1,:)+Prob(3,:);
 p3(1,:)=p10(Div_Map(:)).*p20(Div_Mapb(:));
 p3(2,:)=p10(Div_Map(:)).*(1.0-p20(Div_Mapb(:)));
 p3(3,:)=(1.0-p10(Div_Map(:))).*p20(Div_Mapb(:));
 p3(4,:)=(1.0-p10(Div_Map(:))).*(1.0-p20(Div_Mapb(:)));
//******************************************************************************
//******************************************************************************
// Compute alpha and beta for decoder 2.
//******************************************************************************
 for time=1:my_size-1
//  iv_tima=Div_Map(time);
//  iv_timb=Div_Map(my_size+1-time);
//******************************************************************************
// Alpha beta recursion.
//******************************************************************************
//  for state=1:NUM_STATES
//   t_alpha=0.0;
//   t_beta=0.0;
//   for ip=1:NUM_INPUTS
//    prv_st=P_State(state,ip);
//    nxt_st=N_State(state,ip);
//    ipa=P_Ip(state,ip);                          // Input in the form of 1, 2.
//    opa=Op(prv_st,ipa);                    // Encoded bit in the form of 0, 1.
//    opb=Op(state,ip);                      // Encoded bit in the form of 0, 1.
//    inxa=2*(ipa-1)+opa+1;                                    // Range: 1 to 4.
//    inxb=2*(ip-1)+opb+1;                                     // Range: 1 to 4.
//    ga=My_Gamma2(inxa,time);
//    gb=My_Gamma2(inxb,DATA_SIZE+1-time);
//    proba=Prob(ipa,iv_tima);
//    probb=Prob(ip,iv_timb);
//    prv_alpha=my_alpha(prv_st,time);
//    nxt_beta=my_beta(nxt_st,DATA_SIZE+2-time);
//    t_alpha=t_alpha+ga*proba*prv_alpha;
//    t_beta=t_beta+gb*probb*nxt_beta;
//   end
//   my_alpha(state,time+1)=t_alpha;
//   my_beta(state,DATA_SIZE+1-time)=t_beta;
//  end
//******************************************************************************
// Faster alpha beta recursion.
//******************************************************************************
  my_alpha(:,time+1)=...
  my_alpha(P_State(:,1),time).* ...
  My_Gamma2(Ga_Inx(:,1),time).* ...
  p3(P_Ip(:,1),time)+ ...
  my_alpha(P_State(:,2),time).* ...
  My_Gamma2(Ga_Inx(:,2),time).* ...
  p3(P_Ip(:,2),time)+ ...
  my_alpha(P_State(:,3),time).* ...
  My_Gamma2(Ga_Inx(:,3),time).* ...
  p3(P_Ip(:,3),time)+ ...
  my_alpha(P_State(:,4),time).* ...
  My_Gamma2(Ga_Inx(:,4),time).* ...
  p3(P_Ip(:,4),time);
  my_beta(:,my_size+1-time)=...
  my_beta(N_State(:,1),my_size+2-time).* ...
  My_Gamma2(Gb_Inx(:,1),my_size+1-time)* ...
  p3(1,my_size+1-time)+ ...
  my_beta(N_State(:,2),my_size+2-time).* ...
  My_Gamma2(Gb_Inx(:,2),my_size+1-time)* ...
  p3(2,my_size+1-time)+ ...
  my_beta(N_State(:,3),my_size+2-time).* ...
  My_Gamma2(Gb_Inx(:,3),my_size+1-time)* ...
  p3(3,my_size+1-time)+ ...
  my_beta(N_State(:,4),my_size+2-time).* ...
  My_Gamma2(Gb_Inx(:,4),my_size+1-time)* ...
  p3(4,my_size+1-time);
//******************************************************************************
//  [my_alpha,my_beta]=Normalize_Alpha_Beta(my_alpha,my_beta,time);
//******************************************************************************
  my_alpha(:,time+1)=my_alpha(:,time+1)/ ...
  sum(my_alpha(:,time+1));
  my_beta(:,my_size+1-time)=my_beta(:,my_size+1-time)/ ...
  sum(my_beta(:,my_size+1-time));
 end
//******************************************************************************
// Compute the a posteriori probabilities (APPs).
//******************************************************************************
// Slow version.
//******************************************************************************
// for time=1:DATA_SIZE
//  app(1)=0.0;
//  app(2)=0.0;
//  iv_tim=Div_Map(time);
//  for state=1:NUM_STATES
//   for ip=1:NUM_INPUTS
//    nxt_state=N_State(state,ip);
//    op=Op(state,ip);
//    inx=2*(ip-1)+op+1;
//    ge=My_Gamma2(inx,time);
//    prv_alpha=my_alpha(state,time);
//    nxt_beta=my_beta(nxt_state,time+1);
//    if iter == NUM_ITER
//     my_prob=Prob(ip,iv_tim);
//    else
//     my_prob=1.0;
//    end
//    app(ip)=app(ip)+ge*prv_alpha*nxt_beta*my_prob;
//   end
//  end
//  my_sum=0.0;
//  for ip=1:NUM_INPUTS
//   my_sum=my_sum+app(ip);
//  end
//  for ip=1:NUM_INPUTS
//   Prob(ip,iv_tim)=app(ip)/my_sum;
//  end
// end
//******************************************************************************
// Faster version to compute APPs.
//******************************************************************************
 p4(1,:)=...
 sum(my_alpha(:,:).* ...
 my_beta(N_State(:,1),2:my_size+1).* ...
 My_Gamma2(Gb_Inx(:,1),:).* ...
 repmat(p3(1,:),NUM_STATES,1),'r');
 p4(2,:)=...
 sum(my_alpha(:,:).* ...
 my_beta(N_State(:,2),2:my_size+1).* ...
 My_Gamma2(Gb_Inx(:,2),:).* ...
 repmat(p3(2,:),NUM_STATES,1),'r');
 p4(3,:)=...
 sum(my_alpha(:,:).* ...
 my_beta(N_State(:,3),2:my_size+1).* ...
 My_Gamma2(Gb_Inx(:,3),:).* ...
 repmat(p3(3,:),NUM_STATES,1),'r');
 p4(4,:)=...
 sum(my_alpha(:,:).* ...
 my_beta(N_State(:,4),2:my_size+1).* ...
 My_Gamma2(Gb_Inx(:,4),:).* ...
 repmat(p3(4,:),NUM_STATES,1),'r');
 tmp_sum=sum(p4,'r');
 p4(1,:)=p4(1,:)./tmp_sum;
 p4(2,:)=p4(2,:)./tmp_sum;
 p4(3,:)=p4(3,:)./tmp_sum;
 p4(4,:)=p4(4,:)./tmp_sum;
 p10=p4(1,:)+p4(2,:);
 p20=p4(1,:)+p4(3,:);
 Prob(1,:)=p10(Iv_Map(:)).*p20(Iv_Mapb(:));
 Prob(2,:)=p10(Iv_Map(:)).*(1.0-p20(Iv_Mapb(:)));
 Prob(3,:)=(1.0-p10(Iv_Map(:))).*p20(Iv_Mapb(:));
 Prob(4,:)=(1.0-p10(Iv_Map(:))).*(1.0-p20(Iv_Mapb(:)));
endfunction
