//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get coded 16-QAM symbols.
// Bit format: data1 parity1 data2 parity2.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
function[Coded_Tx_Sym,My_Data]=Get_Coded_16QAM(my_size,gen_vec)
 re_sym1=int(2*grand(1,my_size,'def'));
 re_sym2=int(2*grand(1,my_size,'def'));
 iv_sym1=re_sym1(Div_Map(:));                 // Interleaved data 1. Row vector.
 iv_sym2=re_sym2(Div_Mapb(:));                // Interleaved data 2. Row vector.
 im_parity1=round(convol(gen_vec,re_sym1));
 im_parity2=round(convol(gen_vec,re_sym2));
 iv_parity1=round(convol(gen_vec,iv_sym1));
 iv_parity2=round(convol(gen_vec,iv_sym2));
 im_parity1=modulo(im_parity1(1:my_size),2);
 im_parity2=modulo(im_parity2(1:my_size),2);
 iv_parity1=modulo(iv_parity1(1:my_size),2);
 iv_parity2=modulo(iv_parity2(1:my_size),2);
//******************************************************************************
// 16-QAM coded data.
//******************************************************************************
 Coded_Tx_Sym=[QAM16_Map(8*re_sym1+4*im_parity1+2*re_sym2+im_parity2+1).' ...
               QAM16_Map(8*iv_sym1+4*iv_parity1+2*iv_sym2+iv_parity2+1).'];
 My_Data=[2*re_sym1+re_sym2];
endfunction
//******************************************************************************
