#*******************************************************************************
#    Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for OFDM. A two step frequency offset estimation
# is used. Here OFDM_SIZE=4096. ML_FOFF2_BINS is varied.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt8_inf_snr_foff2bins64_varydata.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt8_inf_snr_foff2bins64_varydata.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
#set term postscript eps color 22
set key left bottom box
set grid xtics ytics mytics lw 0.5, lw 0.5
set format y "%2.1e"
#set output "dmt8_inf_snr_foff2bins64_varydata.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "dmt8_inf_snr_foff2bins64_varydata.dat" t\
     "ML_FOFF2_BINS=64"\
      w linespoints lt 1 lw 2 pt 1
