#*******************************************************************************
#    Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the frequency offset estimation error for coded and uncoded OFDM
# with estimated channel, frequency offset and timing.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt9_foff.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt9_foff.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt9_foff.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "dmt9_rmsfoff1_p512.dat" t\
     "RMS 1st est"\
      w linespoints lt 1 lw 2 pt 1,\
     "dmt9_rmsfoff2_p512.dat" t\
     "RMS 2nd est"\
      w linespoints lt 3 lw 2 pt 2,\
     "dmt9_maxfoff1_p512.dat" t\
     "Max 1st est"\
      w linespoints lt 4 lw 2 pt 3,\
     "dmt9_maxfoff2_p512.dat" t\
     "Max 2nd est"\
      w linespoints lt 5 lw 2 pt 4
