#*******************************************************************************
#    Copyright (C) 2012 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the frequency offset estimation error for coded and uncoded OFDM
# with estimated channel, frequency offset and timing.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt11_foff.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt11_foff.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key right top box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt11_foff.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "../dmt11_e/dmt11_e_rmsfoff1_p512_o4096.dat" t\
     "RMS coarse"\
      w linespoints lt 1 lw 4 pt 1 ps 2,\
     "../dmt11_e/dmt11_e_rmsfoff2_p512_o4096.dat" t\
     "RMS fine"\
      w linespoints lt 3 lw 4 pt 2 ps 2,\
     "../dmt11_e/dmt11_e_maxfoff1_p512_o4096.dat" t\
     "Max coarse"\
      w linespoints lt 4 lw 4 pt 3 ps 2,\
     "../dmt11_e/dmt11_e_maxfoff2_p512_o4096.dat" t\
     "Max fine"\
      w linespoints lt 7 lw 4 pt 4 ps 2
