#*******************************************************************************
#    Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for coded and uncoded OFDM with estimated
# channel, frequency offset and timing. Data interleaving is also used.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt13_ber.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt13_ber.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt13_ber.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "../dmt13_e/dmt13_e_cber_p512_o512.dat" t\
     "DIV, Data=512, Pr"\
      w linespoints lt 1 lw 4 pt 1 ps 2,\
     "../dmt13_i/dmt13_i_cber_p512_o512.dat" t\
     "DIV, Id"\
      w linespoints lt 2 lw 4 pt 2 ps 2,\
     "../dmt11_i/dmt11_i_cber_p512_o512.dat" t\
     "No DIV, Id"\
      w linespoints lt 8 lw 4 pt 7 ps 2,\
     "../dmt11_e/dmt11_e_cber_p512_o512.dat" t\
     "No DIV, Data=512, Pr"\
      w linespoints lt 9 lw 4 pt 8 ps 2,\
     "../dmt11_i/dmt11_i_ucber_p512_o4096.dat" t\
     "UC, Id"\
      w linespoints lt 4 lw 4 pt 3 ps 2,\
     "../dmt13_e/dmt13_e_cber_p512_o1024.dat" t\
     "DIV, Data=1024, Pr"\
      w linespoints lt 3 lw 4 pt 4 ps 2,\
     "../dmt13_e/dmt13_e_cber_p512_o4096.dat" t\
     "DIV, Data=4096, Pr"\
      w linespoints lt 7 lw 4 pt 5 ps 2
