#*******************************************************************************
#    Copyright (C) 2012 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for turbo coded OFDM with estimated
# channel, frequency offset and timing. Data + postamble interleaving is done.
# Postamble is used to detect the residual frequency offset. Postamble size
# is 128 QPSK symbols.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt14_ber_po128.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt14_ber_po128.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
#set term postscript eps color 22
set key left bottom box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
#set output "dmt14_ber_po128.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "../dmt14_e/dmt14_e_cber_po128_ip32.dat" t\
     "ip=32, Pr"\
      w linespoints lt 1 lw 2 pt 1,\
     "../dmt14_e/dmt14_e_cber_po128_ip16.dat" t\
     "ip=16, Pr"\
      w linespoints lt 2 lw 2 pt 2,\
     "../dmt14_e/dmt14_e_cber_po128_ip8.dat" t\
     "ip=8, Pr"\
      w linespoints lt 3 lw 2 pt 3,\
     "../dmt14_e/dmt14_e_cber_po128_ip4.dat" t\
     "ip=4, Pr"\
      w linespoints lt 4 lw 2 pt 4,\
     "../dmt13_i/dmt13_i_cber_p512_o512.dat" t\
     "Ideal"\
      w linespoints lt 5 lw 2 pt 5
