#*******************************************************************************
#    Copyright (C) 2012 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the outage probability for turbo coded OFDM with ideal
# channel, frequency offset and timing. Data + postamble interleaving is done.
# Postamble size # is 256 QPSK symbols. Code rate is unity.
# Outage is computed at the FFT output at the receiver.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt_outage.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt_outage.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt_outage.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "../dmt24_i/dmt24_i_outage.dat" t\
     "Div=1"\
      w linespoints lt 1 lw 4 pt 1 ps 2,\
     "../dmt25_i/dmt25_i_outage.dat" t\
     "Div=2"\
      w linespoints lt 2 lw 4 pt 2 ps 2
